diff --git a/sim/Makefile.am b/sim/Makefile.am
index dd85297c83e5..8a4a160b30cd 100644
--- a/sim/Makefile.am
+++ b/sim/Makefile.am
@@ -188,9 +188,6 @@ endif
 ## Helper targets for running make from the top-level when some subdirs still
 ## have Makefiles in subdirs.
 
-%/libsim.a: | $(SIM_ALL_RECURSIVE_DEPS)
-	$(MAKE) $(AM_MAKEFLAGS) -C $(@D) $(@F)
-
 %/nrun.o: common/nrun.c | %/libsim.a $(SIM_ALL_RECURSIVE_DEPS)
 	$(MAKE) $(AM_MAKEFLAGS) -C $(@D) $(@F)
 
diff --git a/sim/README-HACKING b/sim/README-HACKING
index 38d871b15141..fd6461e5ae90 100644
--- a/sim/README-HACKING
+++ b/sim/README-HACKING
@@ -44,8 +44,6 @@ The Makefile.in of a simulator using the common framework should look like:
 # Not all of these need to be mentioned, only the necessary ones.
 # In fact it is better to *not* mention ones if the value is the default.
 
-# List of object files, less common parts.
-SIM_OBJS =
 # List of flags to always pass to $(CC).
 SIM_EXTRA_CFLAGS =
 # Dependency of `clean' to clean any extra files.
@@ -53,8 +51,6 @@ SIM_EXTRA_CLEAN =
 
 ## COMMON_POST_CONFIG_FRAG
 
-# Rules need to build $(SIM_OBJS), plus whatever else the target wants.
-
 ... target specific rules ...
 --- snip ---
 
diff --git a/sim/aarch64/Makefile.in b/sim/aarch64/Makefile.in
index 94c624291575..82224f06ccf0 100644
--- a/sim/aarch64/Makefile.in
+++ b/sim/aarch64/Makefile.in
@@ -20,7 +20,4 @@
 ### along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/arch-subdir.mk.in b/sim/arch-subdir.mk.in
index 85e1d84ede1d..afa1103a2f11 100644
--- a/sim/arch-subdir.mk.in
+++ b/sim/arch-subdir.mk.in
@@ -35,7 +35,6 @@ LDFLAGS = @LDFLAGS@
 AR = @AR@
 AR_FLAGS = rc
 RANLIB = @RANLIB@
-DTC = @DTC@
 
 LIBTOOL = @LIBTOOL@
 AM_V_lt = $(am__v_lt_@AM_V@)
@@ -65,5 +64,3 @@ MAINT = ; @true
 SIM_INLINE = @SIM_INLINE@
 
 SIM_HW_CFLAGS = @SIM_HW_CFLAGS@
-SIM_HW_OBJS = $(SIM_HW_DEVICES:%=dv-%.o)
-@SIM_ENABLE_HW_FALSE@SIM_HW_OBJS =
diff --git a/sim/arm/Makefile.in b/sim/arm/Makefile.in
index cdf371d844c7..24e1525d6696 100644
--- a/sim/arm/Makefile.in
+++ b/sim/arm/Makefile.in
@@ -19,6 +19,4 @@
 
 SIM_EXTRA_CFLAGS = -DMODET
 
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/avr/Makefile.in b/sim/avr/Makefile.in
index eaf6c4b6a977..202bda36d2fd 100644
--- a/sim/avr/Makefile.in
+++ b/sim/avr/Makefile.in
@@ -15,7 +15,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/bfin/Makefile.in b/sim/bfin/Makefile.in
index 700e641d149c..569c64bb22f5 100644
--- a/sim/bfin/Makefile.in
+++ b/sim/bfin/Makefile.in
@@ -19,8 +19,6 @@
 
 arch = bfin
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = $(SDL_CFLAGS)
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/bpf/Makefile.in b/sim/bpf/Makefile.in
index 1fc98a68cbe5..64ec667c12c7 100644
--- a/sim/bpf/Makefile.in
+++ b/sim/bpf/Makefile.in
@@ -18,8 +18,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = -DWITH_TARGET_WORD_BITSIZE=64
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/common/Make-common.in b/sim/common/Make-common.in
index e14997ae1363..f9f6ed1984c4 100644
--- a/sim/common/Make-common.in
+++ b/sim/common/Make-common.in
@@ -83,24 +83,18 @@ POSTCOMPILE = @true
 # in the simulator's Makefile.in if one is using the default value.  In fact
 # it's preferable not to.
 
-# List of object files, less common parts.
-SIM_OBJS =
 # List of flags to always pass to $(CC).
 SIM_EXTRA_CFLAGS =
-# List of main object files for `run'.
-SIM_RUN_OBJS = nrun.o
-SIM_LIBSIM = libsim.a
 # Dependency of `clean' to clean any extra files.
 SIM_EXTRA_CLEAN =
 
 # Every time a new general purpose source file was added every target's
-# Makefile.in needed to be updated to include the file in SIM_OBJS.
+# Makefile.in needed to be updated to include the file.
 # This doesn't scale.
 # This variable specifies all the generic stuff common to the newer simulators.
 # Things like sim-reason.o can't go here as the cpu may provide its own
 # (though hopefully in time that won't be so).  Things like sim-bits.o can go
 # here.  Some files are used by all simulators (e.g. callback.o).
-# Those files are specified in LIB_OBJS below.
 
 ## End COMMON_PRE_CONFIG_FRAG
 
@@ -124,9 +118,6 @@ BUILD_CFLAGS = $(CFLAGS_FOR_BUILD) $(CSEARCH)
 
 COMMON_DEP_CFLAGS = $(CONFIG_CFLAGS) $(CSEARCH) $(SIM_EXTRA_CFLAGS)
 
-SIM_HW_DEVICES = $(SIM_HW_DEVICES_) $($(arch)_SIM_EXTRA_HW_DEVICES)
-SIM_NEW_COMMON_OBJS = $(SIM_NEW_COMMON_OBJS_) $(SIM_HW_OBJS)
-
 LIBIBERTY_LIB = ../../libiberty/libiberty.a
 BFD_LIB = ../../bfd/libbfd.la
 OPCODES_LIB = ../../opcodes/libopcodes.la
@@ -134,31 +125,12 @@ LIBDEPS = $(BFD_LIB) $(OPCODES_LIB) $(LIBIBERTY_LIB)
 EXTRA_LIBS = $(BFD_LIB) $(OPCODES_LIB) $(LIBIBERTY_LIB) \
 	$(COMMON_LIBS) $(LIBGNU) $(LIBGNU_EXTRA_LIBS)
 
-COMMON_OBJS_NAMES = \
-	callback.o \
-	portability.o \
-	sim-load.o \
-	syscall.o \
-	target-newlib-errno.o \
-	target-newlib-open.o \
-	target-newlib-signal.o \
-	target-newlib-syscall.o \
-	version.o
-COMMON_OBJS = $(COMMON_OBJS_NAMES:%=../common/%)
-
-LIB_OBJS = modules.o $(COMMON_OBJS) $(SIM_OBJS)
-
 COMPILE_FOR_BUILD = $(CC_FOR_BUILD) $(BUILD_CFLAGS)
 LINK_FOR_BUILD = $(CC_FOR_BUILD) $(BUILD_CFLAGS) $(LDFLAGS_FOR_BUILD) -o $@
 
 RUNTESTFLAGS =
 
-all: $(SIM_LIBSIM) $(LIB_OBJS) $(SIM_RUN_OBJS)
-
-libsim.a: $(LIB_OBJS)
-	$(SILENCE) rm -f libsim.a
-	$(ECHO_AR) $(AR) $(AR_FLAGS) libsim.a $(LIB_OBJS)
-	$(ECHO_RANLIB) $(RANLIB) libsim.a
+all:
 
 #
 # Dependency tracking.  Most of this is conditional on GNU Make being
@@ -182,11 +154,6 @@ override COMPILE.pre = source='$<' object='$@' libtool=no \
 override POSTCOMPILE =
 endif
 
-all_object_files = $(LIB_OBJS) $(SIM_RUN_OBJS)
-
-# Dependencies.
--include $(patsubst %.o, $(DEPDIR)/%.Po, $(all_object_files))
-
 test-hw-events: $(srccom)/hw-events.c libsim.a
 	$(ECHO_CCLD) $(LIBTOOL) $(AM_V_lt) --tag=CC --mode=link \
 		$(CC) $(ALL_CFLAGS) -DMAIN -o test-hw-events$(EXEEXT) \
@@ -194,7 +161,7 @@ test-hw-events: $(srccom)/hw-events.c libsim.a
 
 # See sim_pre_argv_init and sim_module_install in sim-module.c for more details.
 modules.c: stamp-modules ; @true
-stamp-modules: Makefile $(SIM_OBJS:.o=.c)
+stamp-modules: Makefile
 	$(ECHO_STAMP) modules.c
 	$(SILENCE) LANG=C ; export LANG ; \
 	LC_ALL=C ; export LC_ALL ; \
@@ -248,7 +215,6 @@ TAGS: force
 
 mostlyclean clean: $(SIM_EXTRA_CLEAN)
 	rm -f *.[oa] *~ core \
-		run$(EXEEXT) libsim.a \
 		modules.c stamp-modules
 
 distclean maintainer-clean realclean: clean
diff --git a/sim/cr16/Makefile.in b/sim/cr16/Makefile.in
index da5062dc39ce..37a91c585313 100644
--- a/sim/cr16/Makefile.in
+++ b/sim/cr16/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program. If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/cris/Makefile.in b/sim/cris/Makefile.in
index 142825fa26d3..b1a2e83bad43 100644
--- a/sim/cris/Makefile.in
+++ b/sim/cris/Makefile.in
@@ -21,6 +21,4 @@
 
 arch = cris
 
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/d10v/Makefile.in b/sim/d10v/Makefile.in
index 6f209a2db1f7..15cfc21807d2 100644
--- a/sim/d10v/Makefile.in
+++ b/sim/d10v/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/erc32/Makefile.in b/sim/erc32/Makefile.in
index 252427d4a388..58afbe1f7476 100644
--- a/sim/erc32/Makefile.in
+++ b/sim/erc32/Makefile.in
@@ -18,9 +18,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-SIM_RUN_OBJS =
-
 READLINE_SRC = $(srcroot)/readline/readline
 
 SIM_EXTRA_CFLAGS = $(READLINE_CFLAGS)
diff --git a/sim/example-synacor/Makefile.in b/sim/example-synacor/Makefile.in
index cece1e543ca7..a8e8fc7d2d5b 100644
--- a/sim/example-synacor/Makefile.in
+++ b/sim/example-synacor/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/frv/Makefile.in b/sim/frv/Makefile.in
index 12af397f4c1e..f577873c057a 100644
--- a/sim/frv/Makefile.in
+++ b/sim/frv/Makefile.in
@@ -17,8 +17,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = @SIM_FRV_TRAPDUMP_FLAGS@
 
 # Some modules don't build cleanly yet.
diff --git a/sim/ft32/Makefile.in b/sim/ft32/Makefile.in
index a84512eaac46..50f497ebb9d7 100644
--- a/sim/ft32/Makefile.in
+++ b/sim/ft32/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/h8300/Makefile.in b/sim/h8300/Makefile.in
index 6843a400826a..7d378cb970f1 100644
--- a/sim/h8300/Makefile.in
+++ b/sim/h8300/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/iq2000/Makefile.in b/sim/iq2000/Makefile.in
index b4679a484391..6114d0e96f31 100644
--- a/sim/iq2000/Makefile.in
+++ b/sim/iq2000/Makefile.in
@@ -16,9 +16,6 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
 
 arch = iq2000
diff --git a/sim/lm32/Makefile.in b/sim/lm32/Makefile.in
index cee1935ba341..d34049a3682e 100644
--- a/sim/lm32/Makefile.in
+++ b/sim/lm32/Makefile.in
@@ -5,6 +5,4 @@
 
 arch = lm32
 
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/m32c/Makefile.in b/sim/m32c/Makefile.in
index cbe0c916e485..4c91e57dd2d0 100644
--- a/sim/m32c/Makefile.in
+++ b/sim/m32c/Makefile.in
@@ -22,7 +22,4 @@
 
 SIM_EXTRA_CFLAGS = -DTIMER_A
 
-SIM_LIBSIM =
-SIM_RUN_OBJS =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/m32r/Makefile.in b/sim/m32r/Makefile.in
index 08cda449ca16..bc7b85694792 100644
--- a/sim/m32r/Makefile.in
+++ b/sim/m32r/Makefile.in
@@ -21,8 +21,6 @@
 
 arch = m32r
 
-SIM_LIBSIM =
-
 # Some modules don't build cleanly yet.
 cpu.o cpu2.o cpux.o m32r.o m32r2.o m32rx.o mloop.o mloop2.o mloopx.o sem.o sim-if.o traps.o: SIM_WERROR_CFLAGS =
 
diff --git a/sim/m68hc11/Makefile.in b/sim/m68hc11/Makefile.in
index f67a94cf9401..5c8ee196a6c4 100644
--- a/sim/m68hc11/Makefile.in
+++ b/sim/m68hc11/Makefile.in
@@ -19,8 +19,6 @@
 
 arch = m68hc11
 
-SIM_LIBSIM =
-
 # We must use 32-bit addresses to support memory bank switching.
 # The WORD_BITSIZE is normally 16 but must be switched (temporarily)
 # to 32 to avoid a bug in the sim-common which uses 'unsigned_word'
diff --git a/sim/mcore/Makefile.in b/sim/mcore/Makefile.in
index 502e8a44a73c..a16303ca2595 100644
--- a/sim/mcore/Makefile.in
+++ b/sim/mcore/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/microblaze/Makefile.in b/sim/microblaze/Makefile.in
index 502e8a44a73c..a16303ca2595 100644
--- a/sim/microblaze/Makefile.in
+++ b/sim/microblaze/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/mips/Makefile.in b/sim/mips/Makefile.in
index c79a831dd782..8829e3d9b0e2 100644
--- a/sim/mips/Makefile.in
+++ b/sim/mips/Makefile.in
@@ -5,8 +5,6 @@
 
 arch = mips
 
-SIM_LIBSIM =
-
 # List of flags to always pass to $(CC).
 SIM_EXTRA_CFLAGS = @SIM_MIPS_SUBTARGET@
 
diff --git a/sim/mn10300/Makefile.in b/sim/mn10300/Makefile.in
index 511d6b5824b7..a545450fdc81 100644
--- a/sim/mn10300/Makefile.in
+++ b/sim/mn10300/Makefile.in
@@ -19,8 +19,6 @@
 
 arch = mn10300
 
-SIM_LIBSIM =
-
 # List of extra flags to always pass to $(CC).
 SIM_EXTRA_CFLAGS = \
 	-DPOLL_QUIT_INTERVAL=0x20 \
diff --git a/sim/moxie/Makefile.in b/sim/moxie/Makefile.in
index d79426631ac0..fd9beedbf1d6 100644
--- a/sim/moxie/Makefile.in
+++ b/sim/moxie/Makefile.in
@@ -17,8 +17,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = -DDTB="\"$(dtbdir)/moxie-gdb.dtb\""
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/msp430/Makefile.in b/sim/msp430/Makefile.in
index 5cdf3096a7a9..7960d8639325 100644
--- a/sim/msp430/Makefile.in
+++ b/sim/msp430/Makefile.in
@@ -17,7 +17,4 @@
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/or1k/Makefile.in b/sim/or1k/Makefile.in
index 19eed022932d..9df0e6d4fa64 100644
--- a/sim/or1k/Makefile.in
+++ b/sim/or1k/Makefile.in
@@ -18,8 +18,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = -DWITH_TARGET_WORD_BITSIZE=32 -DWITH_TARGET_WORD_MSB=31
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/pru/Makefile.in b/sim/pru/Makefile.in
index 9b2f2f0498aa..214d2eea478d 100644
--- a/sim/pru/Makefile.in
+++ b/sim/pru/Makefile.in
@@ -18,7 +18,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/riscv/Makefile.in b/sim/riscv/Makefile.in
index d85f078f250b..e4631052349b 100644
--- a/sim/riscv/Makefile.in
+++ b/sim/riscv/Makefile.in
@@ -17,8 +17,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = -DWITH_TARGET_WORD_BITSIZE=@SIM_RISCV_BITSIZE@
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/rl78/Makefile.in b/sim/rl78/Makefile.in
index 0cc55baf3b5a..f57356eb8077 100644
--- a/sim/rl78/Makefile.in
+++ b/sim/rl78/Makefile.in
@@ -19,8 +19,4 @@
 ### along with the GNU simulators; if not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-SIM_RUN_OBJS =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/rx/Makefile.in b/sim/rx/Makefile.in
index c418da28944a..0c4a1f6ab6b6 100644
--- a/sim/rx/Makefile.in
+++ b/sim/rx/Makefile.in
@@ -22,7 +22,4 @@
 
 SIM_EXTRA_CFLAGS = @SIM_RX_CYCLE_ACCURATE_FLAGS@
 
-SIM_LIBSIM =
-SIM_RUN_OBJS =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/sh/Makefile.in b/sim/sh/Makefile.in
index ceb4878d285c..8abf705126b9 100644
--- a/sim/sh/Makefile.in
+++ b/sim/sh/Makefile.in
@@ -16,7 +16,4 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 ## COMMON_PRE_CONFIG_FRAG
-
-SIM_LIBSIM =
-
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/v850/Makefile.in b/sim/v850/Makefile.in
index 61df283a31c2..dc319dca70aa 100644
--- a/sim/v850/Makefile.in
+++ b/sim/v850/Makefile.in
@@ -17,8 +17,6 @@
 
 ## COMMON_PRE_CONFIG_FRAG
 
-SIM_LIBSIM =
-
 SIM_EXTRA_CFLAGS = -DWITH_TARGET_WORD_BITSIZE=32 -DWITH_TARGET_WORD_MSB=31
 
 ## COMMON_POST_CONFIG_FRAG