diff --git a/sim/bpf/local.mk b/sim/bpf/local.mk
index 4218999c7e72..80bf775104ff 100644
--- a/sim/bpf/local.mk
+++ b/sim/bpf/local.mk
@@ -73,8 +73,7 @@ BUILT_SOURCES += \
 	%D%/mloop-be.c \
 	%D%/stamp-mloop-be
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %D%/mloop-le.c %D%/eng-le.h: %D%/stamp-mloop-le ; @true
diff --git a/sim/cr16/local.mk b/sim/cr16/local.mk
index 19446381c9f5..cb5ae553594b 100644
--- a/sim/cr16/local.mk
+++ b/sim/cr16/local.mk
@@ -47,8 +47,7 @@ BUILT_SOURCES += %D%/simops.h
 	%D%/gencode$(EXEEXT) \
 	%D%/table.c
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %C%_gencode_SOURCES = %D%/gencode.c
diff --git a/sim/cris/local.mk b/sim/cris/local.mk
index 14c8644fe070..3976f6836ef3 100644
--- a/sim/cris/local.mk
+++ b/sim/cris/local.mk
@@ -77,8 +77,7 @@ BUILT_SOURCES += \
 	%D%/mloopv32f.c \
 	%D%/stamp-mloop-v32f
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: What is mono and what does "Use of `mono' is wip" mean (other
diff --git a/sim/d10v/local.mk b/sim/d10v/local.mk
index 967d4e7e543c..63ddb6ea0c58 100644
--- a/sim/d10v/local.mk
+++ b/sim/d10v/local.mk
@@ -48,8 +48,7 @@ BUILT_SOURCES += %D%/simops.h
 	%D%/gencode$(EXEEXT) \
 	%D%/table.c
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %C%_gencode_SOURCES = %D%/gencode.c
diff --git a/sim/frv/local.mk b/sim/frv/local.mk
index c1a10045a708..7d572fccb6ab 100644
--- a/sim/frv/local.mk
+++ b/sim/frv/local.mk
@@ -83,8 +83,7 @@ BUILT_SOURCES += %D%/eng.h
 	%D%/mloop.c \
 	%D%/stamp-mloop
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: Use of `mono' is wip.
diff --git a/sim/iq2000/local.mk b/sim/iq2000/local.mk
index fa498e485950..77804fe69abe 100644
--- a/sim/iq2000/local.mk
+++ b/sim/iq2000/local.mk
@@ -58,8 +58,7 @@ BUILT_SOURCES += %D%/eng.h
 	%D%/mloop.c \
 	%D%/stamp-mloop
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: Use of `mono' is wip.
diff --git a/sim/lm32/local.mk b/sim/lm32/local.mk
index 4fecaca6a389..40f8d524c952 100644
--- a/sim/lm32/local.mk
+++ b/sim/lm32/local.mk
@@ -63,8 +63,7 @@ BUILT_SOURCES += %D%/eng.h
 	%D%/mloop.c \
 	%D%/stamp-mloop
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: Use of `mono' is wip.
diff --git a/sim/m32c/local.mk b/sim/m32c/local.mk
index 7093e248c7e2..a6d22424929c 100644
--- a/sim/m32c/local.mk
+++ b/sim/m32c/local.mk
@@ -53,8 +53,7 @@ noinst_PROGRAMS += %D%/run
 	%D%/m32c.c \
 	%D%/r8c.c
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %C%_opc2c_SOURCES = %D%/opc2c.c
diff --git a/sim/m32r/local.mk b/sim/m32r/local.mk
index 6a6a6d999128..24ef10ef2bcc 100644
--- a/sim/m32r/local.mk
+++ b/sim/m32r/local.mk
@@ -96,8 +96,7 @@ BUILT_SOURCES += \
 	%D%/mloop2.c \
 	%D%/stamp-mloop-2
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: Use of `mono' is wip.
diff --git a/sim/m68hc11/local.mk b/sim/m68hc11/local.mk
index d5faae40ed53..e094918a3210 100644
--- a/sim/m68hc11/local.mk
+++ b/sim/m68hc11/local.mk
@@ -63,8 +63,7 @@ noinst_PROGRAMS += %D%/run
 	%D%/m68hc11int.c \
 	%D%/m68hc12int.c
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %C%_gencode_SOURCES = %D%/gencode.c
diff --git a/sim/mips/local.mk b/sim/mips/local.mk
index 942997240c8e..5f32eee573f0 100644
--- a/sim/mips/local.mk
+++ b/sim/mips/local.mk
@@ -154,8 +154,7 @@ if SIM_MIPS_GEN_MODE_MULTI
 	%D%/stamp-gen-mode-multi-run
 endif
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 $(%C%_BUILT_SRC_FROM_IGEN_ITABLE): %D%/stamp-igen-itable
diff --git a/sim/mn10300/local.mk b/sim/mn10300/local.mk
index 2abd093e8343..1eae112642d4 100644
--- a/sim/mn10300/local.mk
+++ b/sim/mn10300/local.mk
@@ -83,8 +83,7 @@ BUILT_SOURCES += \
 	$(%C%_BUILT_SRC_FROM_IGEN) \
 	%D%/stamp-igen
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 $(%C%_BUILT_SRC_FROM_IGEN): %D%/stamp-igen
diff --git a/sim/or1k/local.mk b/sim/or1k/local.mk
index 71a34db21d8d..a5989d51ddaf 100644
--- a/sim/or1k/local.mk
+++ b/sim/or1k/local.mk
@@ -65,8 +65,7 @@ BUILT_SOURCES += %D%/eng.h
 	%D%/mloop.c \
 	%D%/stamp-mloop
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 ## FIXME: Use of `mono' is wip.
diff --git a/sim/sh/local.mk b/sim/sh/local.mk
index b197fa4c7c37..4f6a4c5e6617 100644
--- a/sim/sh/local.mk
+++ b/sim/sh/local.mk
@@ -49,8 +49,7 @@ BUILT_SOURCES += \
 	%D%/gencode$(EXEEXT) \
 	%D%/table.c
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 %C%_gencode_SOURCES = %D%/gencode.c
diff --git a/sim/v850/local.mk b/sim/v850/local.mk
index 68f61f89505c..973e83c42789 100644
--- a/sim/v850/local.mk
+++ b/sim/v850/local.mk
@@ -78,8 +78,7 @@ BUILT_SOURCES += \
 	$(%C%_BUILT_SRC_FROM_IGEN) \
 	%D%/stamp-igen
 
-## This makes sure build tools are available before building the arch-subdirs.
-SIM_ALL_RECURSIVE_DEPS += $(%C%_BUILD_OUTPUTS)
+## Generating modules.c requires all sources to scan.
 %D%/modules.c: | $(%C%_BUILD_OUTPUTS)
 
 $(%C%_BUILT_SRC_FROM_IGEN): %D%/stamp-igen